#!/usr/bin/env bash
# TA-Proxmenu preloader

[ "${2}" != "q" ] && source /opt/idssys/defaults/colors.inc
source /opt/idssys/defaults/default.inc
source /opt/idssys/ta-proxmenu/defaults.inc

if curl -m 3 -s --head  --request GET https://git.schroedercity.com | grep "HTTP/2 200" > /dev/null; then 
	if [ "${1}" != "tapm" ]; then
		echo -en "${idsCL[LightCyan]}Checking for updates...${idsCL[Default]}"
		echo ""
		udtd=0
	fi

	if [ "${1}" != "tapm" ]; then
		if [ ! -d /opt/idssys/defaults ]; then
			git clone https://git.schroedercity.com/voltron/iDS-Defaults.git /opt/idssys/defaults
		else
			cd /opt/idssys/defaults
			if [ "`git log --pretty=%H ...refs/heads/master^ | head -n 1`" != "`git ls-remote origin -h refs/heads/master |cut -f1`" ]; then
				if [ "${1}" != "tapm" ]; then
					echo -en "\e[1A";
					echo -en "\e[0K\r${idsCL[LightCyan]}Updating iDSSYS-Defaults...${idsCL[Default]}"
					udtd=1
				fi
				git fetch origin master >/dev/null 2>&1
				git reset --hard origin/master >/dev/null 2>&1
				git reflog expire --expire=now --all >/dev/null 2>&1
				git repack -ad >/dev/null 2>&1
				git prune >/dev/null 2>&1
				git pull >/dev/null 2>&1
				[ "${1}" != "tapm" ] && echo -e "${idsCL[Green]}Done${idsCL[Default]}"
			fi
		fi
	fi

	cd /opt/idssys/ta-proxmenu
	if [ "`git log --pretty=%H ...refs/heads/main^ | head -n 1`" != "`git ls-remote origin -h refs/heads/main |cut -f1`" ]; then
		if [ "${1}" != "tapm" ]; then
			[ ${udtd} -eq 0 ] && echo -en "\e[1A";
			echo -en "\e[0K\r${idsCL[LightCyan]}Updating TA-Proxmenu...${idsCL[Default]}"
		fi
		git fetch origin main >/dev/null 2>&1
		git reset --hard origin/main >/dev/null 2>&1
		git reflog expire --expire=now --all >/dev/null 2>&1
		git repack -ad >/dev/null 2>&1
		git prune >/dev/null 2>&1
		git pull >/dev/null 2>&1
		
		if [ "${1}" != "tapm" ]; then
			source /opt/idssys/ta-proxmenu/defaults.inc
			# echo -en "\e[1A";
			# echo -e "\e[0K\r ${idsCL[Green]}Updated to v${VERS}${idsCL[Default]}"
			echo -e " ${idsCL[Green]}Updated to v${VERS}${idsCL[Default]}\n"
		fi
	elif [ "${1}" != "tapm" ] && [ ${udtd} -eq 0 ]; then
		echo -e "\e[1A\e[0K\r ${idsCL[Green]}No updates available${idsCL[Default]}\n"
	fi

else
	echo -e "${idsCL[Red]}Could not connect to 'git.schroedercity.com' for updates${idsCL[Default]}"
fi

if [ "${1}" != "tapm" ] && [ "${1}" != "update" ] && [ "${1}" != "u" ]; then
	/opt/idssys/ta-proxmenu/proxmenu-scripts.sh $1 $2 $3 $4
fi

exit 0

